<!DOCTYPE html>
<html>
  <head>
    <title>Sign in</title>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"
    />
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />

    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.1.3/dist/css/bootstrap.min.css"
      integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO"
      crossorigin="anonymous"
    />
    <script
      src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
      integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/popper.js@1.14.3/dist/umd/popper.min.js"
      integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@4.1.3/dist/js/bootstrap.min.js"
      integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy"
      crossorigin="anonymous"
    ></script>

    <script src="##HYPR_BASE_URL##/static/fixed/utils.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/hyprfido2sdk.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/core.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/fido-util.js"></script>
    <script src="##RP_APP_BASE_URL##/scripts/management.js"></script>
    <link rel="stylesheet" href="##RP_APP_BASE_URL##/styles/site.css" />
  </head>
  <body>
    <!-- login widget -->
    <div class="login-container container">
      <div class="col-xs-12 col-sm-8 offset-sm-2 login-box">
        <div class="login-header">
          <img id="logo" src="##LOGO_URL##" />
          <h5 id="title-heading" class="mt-4 mb-4"></h5>
        </div>
        <div id="error-message" class="alert alert-danger" hidden></div>
        <form onsubmit="return false;" method="post">
          <div class="form-group">
            <div class="form-row">
              <div class="col">
                <input
                  type="email"
                  class="form-control"
                  id="username"
                  name="username"
                  placeholder="Enter your email"
                  autocomplete="username webauthn"
                />
              </div>
              <div id="edit-container" class="col-2" hidden>
                <button type="button" id="edit-button" class="btn btn-link">
                  Edit
                </button>
              </div>
            </div>
          </div>
          <div id="password-container" class="form-group" hidden>
            <input
              type="password"
              class="form-control"
              id="password"
              name="password"
              placeholder="Enter your password"
            />
          </div>
          <div
            id="captcha-container"
            class="captcha-container form-group"
            hidden
          ></div>
          <button
            type="button"
            id="continue-sign-in-button"
            class="btn btn-block branded-button"
            hidden
          >
            Continue
          </button>
          <button
            type="button"
            id="passkey-sign-up-button"
            class="btn btn-block branded-button"
            hidden
          >
            Sign Up with a Passkey
          </button>
          <button
            type="button"
            id="password-sign-in-button"
            class="btn btn-block branded-button"
            hidden
          >
            Sign In
          </button>
          <button
            type="button"
            id="password-sign-up-button"
            class="btn btn-block branded-button"
            hidden
          >
            Sign Up
          </button>
          <button
            type="button"
            id="sign-in-with-uaf-instead-button"
            class="btn btn-block btn-link"
            hidden
          >
            Sign in with a ##UAF_APP_NAME## device instead
          </button>
          <button
            type="button"
            id="sign-in-with-password-instead-button"
            class="btn btn-block btn-link"
            hidden
          >
            Sign in with a password instead
          </button>
          <button
            type="button"
            id="sign-up-instead-button"
            class="btn btn-block btn-link"
            hidden
          >
            Sign up instead
          </button>
          <button
            type="button"
            id="sign-up-with-password-instead-button"
            class="btn btn-block btn-link"
            hidden
          >
            Sign up with a password instead
          </button>
          <button
            type="button"
            id="sign-up-with-passkey-instead-button"
            class="btn btn-block btn-link"
            hidden
          >
            Sign up with a Passkey instead
          </button>
          <button
            type="button"
            id="sign-in-instead-button"
            class="btn btn-block btn-link"
            hidden
          >
            Sign in instead
          </button>
        </form>
      </div>
    </div>

    <!-- UAF modal -->
    <div
      class="modal fade"
      id="uaf_model"
      tabindex="-1"
      role="dialog"
      aria-labelledby="uaf_model_title"
      aria-hidden="true"
    >
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="uaf_model_title">
              Sign in with a ##UAF_APP_NAME## device
            </h5>
            <button
              type="button"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body text-center">
            <div id="qr-code-section" hidden>
              <p>
                Scan the QR code to sign in with the ##UAF_APP_NAME## device
              </p>
              <img
                id="qr-code-image"
                alt="QR code"
                src=""
                style="height: 200px; width: 200px"
              />
            </div>
            <div id="pending-section" hidden>
              <p>Waiting for your sign-in to complete...</p>
            </div>
            <div id="timeout-section" hidden>
              <p>The user cancelled in the app or something took too long.</p>
              <p>Close this dialog and try again.</p>
            </div>
          </div>
          <div class="modal-footer">
            <button
              type="button"
              class="btn btn-secondary"
              data-dismiss="modal"
            >
              Cancel
            </button>
          </div>
        </div>
      </div>
    </div>

    <!--[if IE 8]>
      <script src="//cdnjs.cloudflare.com/ajax/libs/ie8/0.2.5/ie8.js"></script>
    <![endif]-->

    <!--[if lte IE 9]>
      <script src="https://cdn.auth0.com/js/polyfills/1.0/base64.min.js"></script>
      <script src="https://cdn.auth0.com/js/polyfills/1.0/es5-shim.min.js"></script>
    <![endif]-->

    <script src="https://cdn.auth0.com/js/auth0/9.18/auth0.min.js"></script>
    <script src="https://cdn.auth0.com/js/polyfills/1.0/object-assign.min.js"></script>
    <script>
      const PASSKEY_DB_CONNECTION = "##PASSKEY_DB_CONNECTION##";
      const PASSWORD_DB_CONNECTION = "##PASSWORD_DB_CONNECTION##";
      const RP_APP_BASE_URL = "##RP_APP_BASE_URL##";
      const FIDO_USER_VERIFICATION_TYPE = "preferred";
      const FIDO_ALLOW_RESIDENT_KEY = true;
      const FIDO_ATTESTATION_TYPE = "direct";
      const PASSKEY_AUTOFILL_ENABLED =
        "##PASSKEY_AUTOFILL_ENABLED##" === "true";
      const passkeyAutofillAbortController = new AbortController();

      const defaultOptions = {
        rpBaseUrl: RP_APP_BASE_URL,
      };

      const defaultAssertionOptions = {
        ...defaultOptions,
        userVerification: "required",
        authenticatorAttachment: "cross-platform",
      };

      window.addEventListener("load", async () => {
        // auth0.js config
        var config = JSON.parse(
          decodeURIComponent(escape(window.atob("@@config@@")))
        );
        console.log("Auth0 config:", config);

        var leeway = config.internalOptions.leeway;
        if (leeway) {
          var convertedLeeway = parseInt(leeway);

          if (!isNaN(convertedLeeway)) {
            config.internalOptions.leeway = convertedLeeway;
          }
        }

        var params = Object.assign(
          {
            overrides: {
              __tenant: config.auth0Tenant,
              __token_issuer: config.authorizationServer.issuer,
            },
            domain: config.auth0Domain,
            clientID: config.clientID,
            redirectUri: config.callbackURL,
            responseType: "code",
          },
          config.internalOptions
        );

        var webAuth = new auth0.WebAuth(params);

        var captcha = webAuth.renderCaptcha(
          document.querySelector(".captcha-container")
        );

        let uafAbortController;

        // UI elements

        const titleHeading = document.getElementById("title-heading");
        const errorMessageContainer = document.getElementById("error-message");
        const usernameField = document.getElementById("username");
        const editContainer = document.getElementById("edit-container");
        const editButton = document.getElementById("edit-button");
        const passwordContainer = document.getElementById("password-container");
        const passwordField = document.getElementById("password");
        const captchaContainer = document.getElementById("captcha-container");
        const continueSignInButton = document.getElementById(
          "continue-sign-in-button"
        );
        const passkeySignUpButton = document.getElementById(
          "passkey-sign-up-button"
        );
        const passwordSignInButton = document.getElementById(
          "password-sign-in-button"
        );
        const passwordSignUpButton = document.getElementById(
          "password-sign-up-button"
        );
        const signInWithPasswordInsteadButton = document.getElementById(
          "sign-in-with-password-instead-button"
        );
        const signInWithUafInsteadButton = document.getElementById(
          "sign-in-with-uaf-instead-button"
        );
        const signUpInsteadButton = document.getElementById(
          "sign-up-instead-button"
        );
        const signUpWithPasswordInsteadButton = document.getElementById(
          "sign-up-with-password-instead-button"
        );
        const signUpWithPasskeyInsteadButton = document.getElementById(
          "sign-up-with-passkey-instead-button"
        );
        const signInInsteadButton = document.getElementById(
          "sign-in-instead-button"
        );
        const uafQrCodeSection = document.getElementById("qr-code-section");
        const uafQrCodeImage = document.getElementById("qr-code-image");
        const uafPendingSection = document.getElementById("pending-section");
        const uafTimeoutSection = document.getElementById("timeout-section");

        const submitButtons = [
          continueSignInButton,
          passwordSignInButton,
          passkeySignUpButton,
          passwordSignUpButton,
        ];

        // Helpers

        function showElement(element) {
          element.removeAttribute("hidden");
        }

        function hideElement(element) {
          if (!element.attributes.getNamedItem("hidden")) {
            element.setAttribute("hidden", "");
          }
        }

        function enableElement(element) {
          element.disabled = false;
        }

        function disableElement(element) {
          element.disabled = true;
        }

        function setSubmitButton(newSubmitButton) {
          // set all submit buttons back to just buttons
          for (const button of submitButtons) {
            button.setAttribute("type", "button");
          }

          if (newSubmitButton) {
            newSubmitButton.setAttribute("type", "submit");
          }
        }

        function displayError(err) {
          captcha.reload();
          errorMessageContainer.innerText =
            err.policy || err.description || err.message || err;
          showElement(errorMessageContainer);
        }

        function submitAuth0(username, password) {
          webAuth.login(
            {
              realm: PASSKEY_DB_CONNECTION,
              username: username,
              password: password,
              captcha: captcha.getValue(),
            },
            function (err) {
              if (err) displayError(err);
            }
          );
        }

        // UI orchestration

        function updateButtonState() {
          if (usernameField.value) {
            enableElement(continueSignInButton);
            enableElement(passkeySignUpButton);
          } else {
            disableElement(continueSignInButton);
            disableElement(passkeySignUpButton);
          }
          if (usernameField.value && passwordField.value) {
            enableElement(passwordSignInButton);
            enableElement(passwordSignUpButton);
          } else {
            disableElement(passwordSignInButton);
            disableElement(passwordSignUpButton);
          }

          hideElement(errorMessageContainer);
        }

        function showBeginSignIn() {
          titleHeading.innerText = "Let's sign you in";

          hideElement(errorMessageContainer);
          enableElement(usernameField);
          hideElement(editContainer);
          hideElement(passwordContainer);
          hideElement(captchaContainer);
          showElement(continueSignInButton);
          hideElement(passkeySignUpButton);
          hideElement(passwordSignInButton);
          hideElement(passwordSignUpButton);
          hideElement(signInWithPasswordInsteadButton);
          hideElement(signInWithUafInsteadButton);
          showElement(signUpInsteadButton);
          hideElement(signUpWithPasswordInsteadButton);
          hideElement(signUpWithPasskeyInsteadButton);
          hideElement(signInInsteadButton);

          updateButtonState();
          setSubmitButton(continueSignInButton);
          usernameField.focus();
        }

        function showPasswordSignIn() {
          hideElement(errorMessageContainer);
          disableElement(usernameField);
          showElement(editContainer);
          showElement(passwordContainer);
          showElement(captchaContainer);
          hideElement(continueSignInButton);
          hideElement(passkeySignUpButton);
          showElement(passwordSignInButton);
          hideElement(passwordSignUpButton);
          hideElement(signInWithPasswordInsteadButton);
          hideElement(signInWithUafInsteadButton);
          showElement(signUpInsteadButton);
          hideElement(signUpWithPasswordInsteadButton);
          hideElement(signUpWithPasskeyInsteadButton);
          hideElement(signInInsteadButton);

          updateButtonState();
          setSubmitButton(passwordSignInButton);
          passwordField.value = "";
          passwordField.focus();
        }

        function showBeginSignUp() {
          titleHeading.innerText = "Let's get you signed up";

          hideElement(errorMessageContainer);
          enableElement(usernameField);
          hideElement(editContainer);
          hideElement(passwordContainer);
          hideElement(captchaContainer);
          hideElement(continueSignInButton);
          showElement(passkeySignUpButton);
          hideElement(passwordSignInButton);
          hideElement(passwordSignUpButton);
          hideElement(signInWithPasswordInsteadButton);
          hideElement(signInWithUafInsteadButton);
          hideElement(signUpInsteadButton);
          showElement(signUpWithPasswordInsteadButton);
          hideElement(signUpWithPasskeyInsteadButton);
          showElement(signInInsteadButton);

          updateButtonState();
          setSubmitButton(passkeySignUpButton);
          usernameField.focus();
        }

        function showPasswordSignUp() {
          hideElement(errorMessageContainer);
          enableElement(usernameField);
          hideElement(editContainer);
          showElement(passwordContainer);
          showElement(captchaContainer);
          hideElement(continueSignInButton);
          hideElement(passkeySignUpButton);
          hideElement(passwordSignInButton);
          showElement(passwordSignUpButton);
          hideElement(signInWithPasswordInsteadButton);
          hideElement(signInWithUafInsteadButton);
          hideElement(signUpInsteadButton);
          hideElement(signUpWithPasswordInsteadButton);
          showElement(signUpWithPasskeyInsteadButton);
          showElement(signInInsteadButton);

          updateButtonState();
          setSubmitButton(passwordSignUpButton);
          passwordField.value = "";
          passwordField.focus();
        }

        // Password authentication / registration

        function passwordSignIn(e) {
          e.preventDefault();
          hideElement(errorMessageContainer);
          const button = this;
          disableElement(button);

          webAuth.login(
            {
              realm: PASSWORD_DB_CONNECTION,
              username: usernameField.value,
              password: passwordField.value,
              captcha: captcha.getValue(),
            },
            function (err) {
              if (err) {
                enableElement(button);
                return displayError(err);
              }
            }
          );
        }

        function passwordSignUp(e) {
          e.preventDefault();
          hideElement(errorMessageContainer);
          const button = this;
          disableElement(button);

          webAuth.redirect.signupAndLogin(
            {
              connection: PASSWORD_DB_CONNECTION,
              email: usernameField.value,
              password: passwordField.value,
              captcha: captcha.getValue(),
            },
            function (err) {
              if (err) {
                enableElement(button);
                return displayError(err);
              }
            }
          );
        }

        // Passkey authentication / registration

        async function passkeySignIn(e) {
          e.preventDefault();
          hideElement(errorMessageContainer);
          const button = this;
          disableElement(button);

          const username = usernameField.value;

          // first check if user has any FIDO devices
          let devicesResult;
          try {
            devicesResult = await getFidoAuthenticationMethods({
              rpBaseUrl: RP_APP_BASE_URL,
              username,
            });
          } catch (err) {
            enableElement(button);
            return displayError(err);
          }
          if (!devicesResult.fido2 && !devicesResult.uaf) {
            // no devices - prompt for password instead
            return showPasswordSignIn();
          } else if (!devicesResult.fido2) {
            // no FIDO2 devices - prompt for UAF
            return uafSignIn();
          }

          // abort any pending passkey autofill request
          passkeyAutofillAbortController.abort(
            "Passkey autofill being ignored"
          );

          // devices exist; do full FIDO2 auth
          let result;
          try {
            result = await authenticatePasskey({
              ...defaultAssertionOptions,
              username,
            });
          } catch (err) {
            enableElement(button);
            if (err.name === "NotAllowedError") {
              showElement(signInWithPasswordInsteadButton);
              if (devicesResult.uaf) {
                showElement(signInWithUafInsteadButton);
              }
              return displayError(
                "There was an issue signing in with your passkey"
              );
            }
            return displayError(err);
          }

          submitAuth0(result.username, result.token);
        }

        async function passkeySignUp(e) {
          e.preventDefault();
          hideElement(errorMessageContainer);
          const button = this;
          disableElement(button);

          const username = usernameField.value;

          // abort any pending passkey autofill request
          passkeyAutofillAbortController.abort(
            "Passkey autofill being ignored"
          );

          let result;
          try {
            result = await registerPasskey({
              rpBaseUrl: RP_APP_BASE_URL,
              username,
              displayName: username,
            });
          } catch (err) {
            enableElement(button);
            if (err.name === "NotAllowedError") {
              return displayError("There was an issue enrolling your passkey");
            }
            return displayError(err);
          }

          submitAuth0(result.username, result.token);
        }

        // UAF authentication

        async function uafSignIn() {
          hideElement(errorMessageContainer);
          uafAbortController = new AbortController();

          const username = usernameField.value;

          let result;
          try {
            result = await authenticateUaf({
              ...defaultOptions,
              username,
              displayQrCode: (qrCodeDataUrl) => {
                uafQrCodeImage.src = qrCodeDataUrl;
                $("#uaf_model").modal("show");
                showElement(uafQrCodeSection);
                hideElement(uafPendingSection);
                hideElement(uafTimeoutSection);
              },
              displayPendingMessage: () => {
                hideElement(uafQrCodeSection);
                showElement(uafPendingSection);
                hideElement(uafTimeoutSection);
              },
              displayTimeoutMessage: () => {
                hideElement(uafQrCodeSection);
                hideElement(uafPendingSection);
                showElement(uafTimeoutSection);
              },
              abortSignal: uafAbortController.signal,
            });
          } catch (err) {
            return displayError(err);
          }

          if (result) {
            submitAuth0(result.username, result.token);
          }
        }

        // Event handlers

        usernameField.addEventListener("keyup", updateButtonState);
        passwordField.addEventListener("keyup", updateButtonState);

        continueSignInButton.addEventListener("click", passkeySignIn);
        editButton.addEventListener("click", showBeginSignIn);
        passwordSignInButton.addEventListener("click", passwordSignIn);
        signInWithPasswordInsteadButton.addEventListener(
          "click",
          showPasswordSignIn
        );
        signInWithUafInsteadButton.addEventListener("click", uafSignIn);
        signUpInsteadButton.addEventListener("click", showBeginSignUp);

        passkeySignUpButton.addEventListener("click", passkeySignUp);
        passwordSignUpButton.addEventListener("click", passwordSignUp);
        signUpWithPasswordInsteadButton.addEventListener(
          "click",
          showPasswordSignUp
        );
        signUpWithPasskeyInsteadButton.addEventListener(
          "click",
          showBeginSignUp
        );
        signInInsteadButton.addEventListener("click", showBeginSignIn);
        $("#uaf_model").on("hide.bs.modal", () => {
          // offer password auth
          enableElement(continueSignInButton);
          showElement(signInWithPasswordInsteadButton);
          // stop uaf polling
          uafAbortController.abort();
        });

        // Initial state
        showBeginSignIn();

        // Automatically continue if login_hint was passed
        const { login_hint } = config.extraParams;
        if (login_hint) {
          usernameField.value = login_hint;
          enableElement(continueSignInButton);
          continueSignInButton.click();
        }

        // Attempt passkey autofill
        if (PASSKEY_AUTOFILL_ENABLED && (await isPasskeyAutofillSupported())) {
          let result;
          try {
            result = await authenticatePasskey({
              ...defaultAssertionOptions,
              username: "",
              attemptAutofill: true,
              abortSignal: passkeyAutofillAbortController.signal,
            });
          } catch (err) {
            return console.error("Error with passkey autofill:", err);
          }

          // display selected user
          usernameField.value = result.username;
          disableElement(usernameField);

          submitAuth0(result.username, result.token);
        }
      });
    </script>
  </body>
</html>
